# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List

try:
    from pydantic.v1 import BaseModel, Field, StrictStr, conlist, validator
except ImportError:
    from pydantic import BaseModel, Field, StrictStr, conlist, validator

from mozart_api.models.compression import Compression


class CompressionFeature(BaseModel):
    """
    CompressionFeature
    """

    value: StrictStr = Field(default=..., description="Selected compression value")
    default: Compression = Field(...)
    range: conlist(Compression, unique_items=True) = Field(
        default=..., description="compression range"
    )
    __properties = ["value", "default", "range"]

    @validator("value")
    def value_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ("off", "medium", "maximum"):
            raise ValueError("must be one of enum values ('off', 'medium', 'maximum')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CompressionFeature:
        """Create an instance of CompressionFeature from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of default
        if self.default:
            _dict["default"] = self.default.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in range (list)
        _items = []
        if self.range:
            for _item in self.range:
                if _item:
                    _items.append(_item.to_dict())
            _dict["range"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CompressionFeature:
        """Create an instance of CompressionFeature from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CompressionFeature.parse_obj(obj)

        _obj = CompressionFeature.parse_obj(
            {
                "value": obj.get("value"),
                "default": (
                    Compression.from_dict(obj.get("default"))
                    if obj.get("default") is not None
                    else None
                ),
                "range": (
                    [Compression.from_dict(_item) for _item in obj.get("range")]
                    if obj.get("range") is not None
                    else None
                ),
            }
        )
        return _obj
