# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional

try:
    from pydantic.v1 import BaseModel, Field
except ImportError:
    from pydantic import BaseModel, Field

from mozart_api.models.overlay_play_request_text_to_speech_text_to_speech import (
    OverlayPlayRequestTextToSpeechTextToSpeech,
)


class OverlayPlayRequestTextToSpeech(BaseModel):
    """
    OverlayPlayRequestTextToSpeech
    """

    text_to_speech: Optional[OverlayPlayRequestTextToSpeechTextToSpeech] = Field(
        default=None, alias="textToSpeech"
    )
    __properties = ["textToSpeech"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OverlayPlayRequestTextToSpeech:
        """Create an instance of OverlayPlayRequestTextToSpeech from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of text_to_speech
        if self.text_to_speech:
            _dict["textToSpeech"] = self.text_to_speech.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OverlayPlayRequestTextToSpeech:
        """Create an instance of OverlayPlayRequestTextToSpeech from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OverlayPlayRequestTextToSpeech.parse_obj(obj)

        _obj = OverlayPlayRequestTextToSpeech.parse_obj(
            {
                "text_to_speech": (
                    OverlayPlayRequestTextToSpeechTextToSpeech.from_dict(
                        obj.get("textToSpeech")
                    )
                    if obj.get("textToSpeech") is not None
                    else None
                )
            }
        )
        return _obj
