# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional

try:
    from pydantic.v1 import BaseModel, StrictBool, StrictStr, validator
except ImportError:
    from pydantic import BaseModel, StrictBool, StrictStr, validator


class PlayQueueSettings(BaseModel):
    """
    PlayQueueSettings
    """

    consume: Optional[StrictBool] = None
    gapless: Optional[StrictBool] = None
    repeat: Optional[StrictStr] = None
    shuffle: Optional[StrictBool] = None
    __properties = ["consume", "gapless", "repeat", "shuffle"]

    @validator("repeat")
    def repeat_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ("all", "track", "none"):
            raise ValueError("must be one of enum values ('all', 'track', 'none')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PlayQueueSettings:
        """Create an instance of PlayQueueSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PlayQueueSettings:
        """Create an instance of PlayQueueSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PlayQueueSettings.parse_obj(obj)

        _obj = PlayQueueSettings.parse_obj(
            {
                "consume": obj.get("consume"),
                "gapless": obj.get("gapless"),
                "repeat": obj.get("repeat"),
                "shuffle": obj.get("shuffle"),
            }
        )
        return _obj
