# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional

try:
    from pydantic.v1 import BaseModel, Field, StrictStr, conint, conlist
except ImportError:
    from pydantic import BaseModel, Field, StrictStr, conint, conlist


class RoomCompensationRange(BaseModel):
    """
    RoomCompensationRange
    """

    default: conlist(StrictStr) = Field(
        default=...,
        description="List of room compensation sweeps to combine. No room compensation is done if this list is empty. The maximum length of this list is product specific. ",
    )
    max_items: Optional[conint(strict=True, le=20, ge=1)] = Field(
        default=None,
        alias="maxItems",
        description="Maximum number of items in the `value` field",
    )
    range: conlist(StrictStr) = Field(
        default=..., description="Possible values for the `value` field"
    )
    __properties = ["default", "maxItems", "range"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RoomCompensationRange:
        """Create an instance of RoomCompensationRange from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RoomCompensationRange:
        """Create an instance of RoomCompensationRange from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RoomCompensationRange.parse_obj(obj)

        _obj = RoomCompensationRange.parse_obj(
            {
                "default": obj.get("default"),
                "max_items": obj.get("maxItems"),
                "range": obj.get("range"),
            }
        )
        return _obj
