# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union

try:
    from pydantic.v1 import BaseModel, StrictFloat, StrictInt
except ImportError:
    from pydantic import BaseModel, StrictFloat, StrictInt


class RoomCompensationResponse(BaseModel):
    """
    RoomCompensationResponse
    """

    frequency: Optional[StrictInt] = None
    gain: Optional[Union[StrictFloat, StrictInt]] = None
    __properties = ["frequency", "gain"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RoomCompensationResponse:
        """Create an instance of RoomCompensationResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RoomCompensationResponse:
        """Create an instance of RoomCompensationResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RoomCompensationResponse.parse_obj(obj)

        _obj = RoomCompensationResponse.parse_obj(
            {"frequency": obj.get("frequency"), "gain": obj.get("gain")}
        )
        return _obj
