# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union

try:
    from pydantic.v1 import BaseModel, Field, StrictBool, StrictFloat, StrictInt
except ImportError:
    from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt


class VideoTimings(BaseModel):
    """
    VideoTimings
    """

    horizontal_resolution: Optional[StrictInt] = Field(
        default=None, alias="horizontalResolution"
    )
    interlaced: Optional[StrictBool] = None
    refresh_rate: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, alias="refreshRate"
    )
    vertical_resolution: Optional[StrictInt] = Field(
        default=None, alias="verticalResolution"
    )
    __properties = [
        "horizontalResolution",
        "interlaced",
        "refreshRate",
        "verticalResolution",
    ]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> VideoTimings:
        """Create an instance of VideoTimings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> VideoTimings:
        """Create an instance of VideoTimings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return VideoTimings.parse_obj(obj)

        _obj = VideoTimings.parse_obj(
            {
                "horizontal_resolution": obj.get("horizontalResolution"),
                "interlaced": obj.get("interlaced"),
                "refresh_rate": obj.get("refreshRate"),
                "vertical_resolution": obj.get("verticalResolution"),
            }
        )
        return _obj
